## AwnEffects AwnEffects |

## Functions

gboolean | (*AwnEffectsOpfn) ()
AwnEffects * | awn_effects_new_for_widget ()
void | awn_effects_start ()
void | awn_effects_stop ()
void | awn_effects_start_ex ()
void | awn_effects_set_icon_size ()
cairo_t * | awn_effects_cairo_create ()
cairo_t * | awn_effects_cairo_create_clipped ()
void | awn_effects_cairo_destroy ()
void | awn_effects_add_overlay ()
void | awn_effects_remove_overlay ()
GList * | awn_effects_get_overlays ()
void | awn_effects_redraw ()
void | awn_effects_main_effect_loop ()
void | awn_effects_emit_anim_start ()
void | awn_effects_emit_anim_end ()

## Properties

gboolean | active | Read / Write / Construct
DesktopAgnosticColor * | active-rect-color | Read / Write
DesktopAgnosticColor * | active-rect-outline | Read / Write
gchar * | arrow-png | Read / Write / Construct
gint | arrows-count | Read / Write / Construct
gint | border-clip | Read / Write / Construct
gchar * | custom-active-png | Read / Write / Construct
gboolean | depressed | Read / Write / Construct
DesktopAgnosticColor * | dot-color | Read / Write
gint | effects | Read / Write / Construct
gfloat | icon-alpha | Read / Write / Construct
gint | icon-offset | Read / Write / Construct
gboolean | indirect-paint | Read / Write / Construct
gboolean | make-shadow | Read / Write / Construct
gboolean | no-clear | Read / Write / Construct
GtkPositionType | position | Read / Write / Construct
gfloat | progress | Read / Write / Construct
gfloat | reflection-alpha | Read / Write / Construct
gint | reflection-offset | Read / Write / Construct
gboolean | reflection-visible | Read / Write / Construct
gchar * | spotlight-png | Read / Write / Construct
GtkWidget * | widget | Read / Write

## Signals

void | animation-end | Run First
void | animation-start | Run First

## Types and Values

enum | AwnEffect
#define | AWN_EFFECTS_ACTIVE_RECT_PADDING
| AwnEffectsOp
struct | AwnEffects

## Object Hierarchy

        GObject
        ╰── AwnEffects

## Description

## Functions

### AwnEffectsOpfn ()

    gboolean
    (*AwnEffectsOpfn) (AwnEffects *fx,
                       GtkAllocation *alloc,
                       gpointer user_data);

### awn_effects_new_for_widget ()

    AwnEffects *
    awn_effects_new_for_widget (GtkWidget *widget);

### awn_effects_start ()

    void
    awn_effects_start (AwnEffects *fx,
                       const AwnEffect effect);

### awn_effects_stop ()

    void
    awn_effects_stop (AwnEffects *fx,
                      const AwnEffect effect);

### awn_effects_start_ex ()

    void
    awn_effects_start_ex (AwnEffects *fx,
                          const AwnEffect effect,
                          gint max_loops,
                          gboolean signal_start,
                          gboolean signal_end);

### awn_effects_set_icon_size ()

    void
    awn_effects_set_icon_size (AwnEffects *fx,
                               gint width,
                               gint height,
                               gboolean requestSize);

### awn_effects_cairo_create ()

    cairo_t *
    awn_effects_cairo_create (AwnEffects *fx);

### awn_effects_cairo_create_clipped ()

    cairo_t *
    awn_effects_cairo_create_clipped (AwnEffects *fx,
                                      GdkEventExpose *event);

### awn_effects_cairo_destroy ()

    void
    awn_effects_cairo_destroy (AwnEffects *fx);

### awn_effects_add_overlay ()

    void
    awn_effects_add_overlay (AwnEffects *fx,
                             AwnOverlay *overlay);

### awn_effects_remove_overlay ()

    void
    awn_effects_remove_overlay (AwnEffects *fx,
                                AwnOverlay *overlay);

### awn_effects_get_overlays ()

    GList *
    awn_effects_get_overlays (AwnEffects *fx);

### awn_effects_redraw ()

    void
    awn_effects_redraw (AwnEffects *fx);

### awn_effects_main_effect_loop ()

    void
    awn_effects_main_effect_loop (AwnEffects *fx);

### awn_effects_emit_anim_start ()

    void
    awn_effects_emit_anim_start (AwnEffects *fx,
                                 AwnEffect effect);

### awn_effects_emit_anim_end ()

    void
    awn_effects_emit_anim_end (AwnEffects *fx,
                               AwnEffect effect);

## Types and Values

### enum AwnEffect

#### Members

AWN_EFFECT_NONE |  |
AWN_EFFECT_OPENING |  |
AWN_EFFECT_CLOSING |  |
AWN_EFFECT_HOVER |  |
AWN_EFFECT_LAUNCHING |  |
AWN_EFFECT_ATTENTION |  |
AWN_EFFECT_DESATURATE |  |

### AWN_EFFECTS_ACTIVE_RECT_PADDING

    #define AWN_EFFECTS_ACTIVE_RECT_PADDING 3

### AwnEffectsOp

    typedef struct {
        AwnEffectsOpfn      fn;
        gpointer            data;
    } AwnEffectsOp;

### struct AwnEffects

    struct AwnEffects;

Class containing all necessary variables for effects state for particular widget.

## Property Details

### The `“active”` property

      “active”                   gboolean

Determines whether to draw active hint around icon.

Flags: Read / Write / Construct

Default value: FALSE

### The `“active-rect-color”` property

      “active-rect-color”        DesktopAgnosticColor *

Color used for painting active rectangle.

Flags: Read / Write

### The `“active-rect-outline”` property

      “active-rect-outline”      DesktopAgnosticColor *

Color used for painting outline of active rectangle.

Flags: Read / Write

### The `“arrow-png”` property

      “arrow-png”                gchar *

Icon to draw when arrows-count is more than 0.

Flags: Read / Write / Construct

Default value: "__awn_internal_arrow1"

### The `“arrows-count”` property

      “arrows-count”             gint

Number of arrows to draw.

Flags: Read / Write / Construct

Allowed values: >= 0

Default value: 0

### The `“border-clip”` property

      “border-clip”              gint

Clips border of the icon.

Flags: Read / Write / Construct

Allowed values: >= 0

Default value: 0

### The `“custom-active-png”` property

      “custom-active-png”        gchar *

Custom icon to draw when in active state.

Flags: Read / Write / Construct

Default value: NULL

### The `“depressed”` property

      “depressed”                gboolean

Determines whether to draw the icon slightly desaturated.

Flags: Read / Write / Construct

Default value: FALSE

### The `“dot-color”` property

      “dot-color”                DesktopAgnosticColor *

Color used for painting glowing dot.

Flags: Read / Write

### The `“effects”` property

      “effects”                  gint

Active effects set for this instance.

Flags: Read / Write / Construct

Default value: 0

### The `“icon-alpha”` property

      “icon-alpha”               gfloat

Alpha value of drawn icon.

Flags: Read / Write / Construct

Allowed values: [0,1]

Default value: 1

### The `“icon-offset”` property

      “icon-offset”              gint

Offset of drawn icon to window border.

Flags: Read / Write / Construct

Default value: 0

### The `“indirect-paint”` property

      “indirect-paint”           gboolean

Determines whether to apply transforms directly on the window or paint to a buffer instead.

Flags: Read / Write / Construct

Default value: TRUE

### The `“make-shadow”` property

      “make-shadow”              gboolean

Determines whether shadow is drawn around icon.

Flags: Read / Write / Construct

Default value: FALSE

### The `“no-clear”` property

      “no-clear”                 gboolean

Don't clear background to transparent.

Flags: Read / Write / Construct

Default value: TRUE

### The `“position”` property

      “position”                 GtkPositionType

Icon position.

Flags: Read / Write / Construct

Default value: GTK_POS_BOTTOM

### The `“progress”` property

      “progress”                 gfloat

Value displayed on extra progress pie drawn on the icon.

Flags: Read / Write / Construct

Allowed values: [0,1]

Default value: 1

### The `“reflection-alpha”` property

      “reflection-alpha”         gfloat

Alpha value of drawn reflection.

Flags: Read / Write / Construct

Allowed values: [0,1]

Default value: 0.25

### The `“reflection-offset”` property

      “reflection-offset”        gint

Offset of drawn reflection to icon.

Flags: Read / Write / Construct

Default value: 0

### The `“reflection-visible”` property

      “reflection-visible”       gboolean

Determines whether reflection is visible.

Flags: Read / Write / Construct

Default value: TRUE

### The `“spotlight-png”` property

      “spotlight-png”            gchar *

Icon to draw for the spotlight effect.

Flags: Read / Write / Construct

Default value: "__awn_internal_spotlight"

### The `“widget”` property

      “widget”                   GtkWidget *

Widget to draw to.

Flags: Read / Write

## Signal Details

### The `“animation-end”` signal

    void
    user_function (AwnEffects *awneffects,
                   AwnEffect   arg1,
                   gpointer    user_data)

#### Parameters

awneffects | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run First

### The `“animation-start”` signal

    void
    user_function (AwnEffects *awneffects,
                   AwnEffect   arg1,
                   gpointer    user_data)

#### Parameters

awneffects | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run First